<?php

namespace Drupal\bpmn_io\Plugin\ECA\Modeller;

use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\eca_modeller_bpmn\ModellerBpmnBase;

/**
 * Plugin implementation of the ECA Modeller.
 *
 * @EcaModeller(
 *   id = "bpmn_io",
 * )
 */
class BpmnIo extends ModellerBpmnBase {

  use StringTranslationTrait;

  /**
   * {@inheritdoc}
   */
  protected function xmlNsPrefix(): string {
    return 'bpmn2:';
  }

  /**
   * {@inheritdoc}
   */
  public function isEditable(): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function edit(): array {
    return [
      '#markup' => $this->t('Save'),
      '#prefix' => '<div id="bpmn-io"><div class="canvas"></div><div class="property-panel"></div><div class="btn save-button">',
      '#suffix' => '</div></div>',
      '#attached' => [
        'library' => [
          'bpmn_io/ui',
        ],
        'drupalSettings' => [
          'bpmn_io' => [
            'id' => $this->eca->id(),
            'modeller' => 'bpmn_io',
            'bpmn' => $this->eca->getModel()->getModeldata(),
            'templates' => $this->getTemplates(),
          ],
        ],
      ],
    ];
  }

}
